
_Get_Frecv:

;frecv_lib_p18f_pic.mbas,60 :: 		DIM HigB AS byte
;frecv_lib_p18f_pic.mbas,62 :: 		RST_pin = 0
	BCF         RST_pin+0, BitPos(RST_pin+0) 
;frecv_lib_p18f_pic.mbas,63 :: 		TMR0_pin_dir = 1
	BSF         TMR0_pin_dir+0, BitPos(TMR0_pin_dir+0) 
;frecv_lib_p18f_pic.mbas,64 :: 		RST_pin_dir = 0
	BCF         RST_pin_dir+0, BitPos(RST_pin_dir+0) 
;frecv_lib_p18f_pic.mbas,66 :: 		T0CON = %10100111  '(HS)
	MOVLW       167
	MOVWF       T0CON+0 
;frecv_lib_p18f_pic.mbas,68 :: 		TMR0H = 0
	CLRF        TMR0H+0 
;frecv_lib_p18f_pic.mbas,69 :: 		TMR0L = 0
	CLRF        TMR0L+0 
;frecv_lib_p18f_pic.mbas,71 :: 		T1CON = %10110000
	MOVLW       176
	MOVWF       T1CON+0 
;frecv_lib_p18f_pic.mbas,73 :: 		TMR1H = V1
	MOVF        FARG_Get_Frecv_V1+0, 0 
	MOVWF       TMR1H+0 
;frecv_lib_p18f_pic.mbas,74 :: 		TMR1L = V2
	MOVF        FARG_Get_Frecv_V2+0, 0 
	MOVWF       TMR1L+0 
;frecv_lib_p18f_pic.mbas,75 :: 		PIR1.0 = 0
	BCF         PIR1+0, 0 
;frecv_lib_p18f_pic.mbas,76 :: 		LowB = 0
	CLRF        R8 
;frecv_lib_p18f_pic.mbas,79 :: 		bsf   T1CON,0
	BSF         T1CON+0, 0, 0
;frecv_lib_p18f_pic.mbas,80 :: 		bsf   RST_pin_dir, BitPos(RST_pin_dir + 0)
	BSF         RST_pin_dir+0, BitPos(RST_pin_dir+0), 0
;frecv_lib_p18f_pic.mbas,81 :: 		loop:
loop:
;frecv_lib_p18f_pic.mbas,82 :: 		btfss PIR1,0
	BTFSS       PIR1+0, 0, 0
;frecv_lib_p18f_pic.mbas,83 :: 		goto  loop
	GOTO        loop
;frecv_lib_p18f_pic.mbas,84 :: 		nop
	NOP
;frecv_lib_p18f_pic.mbas,85 :: 		nop
	NOP
;frecv_lib_p18f_pic.mbas,86 :: 		nop
	NOP
;frecv_lib_p18f_pic.mbas,87 :: 		nop
	NOP
;frecv_lib_p18f_pic.mbas,88 :: 		nop
	NOP
;frecv_lib_p18f_pic.mbas,89 :: 		bcf   RST_pin, BitPos(RST_pin+0)
	BCF         RST_pin+0, BitPos(RST_pin+0), 0
;frecv_lib_p18f_pic.mbas,90 :: 		bcf   RST_pin_dir, BitPos(RST_pin_dir+0)
	BCF         RST_pin_dir+0, BitPos(RST_pin_dir+0), 0
;frecv_lib_p18f_pic.mbas,91 :: 		bcf   T1CON, 0
	BCF         T1CON+0, 0, 0
;frecv_lib_p18f_pic.mbas,92 :: 		clrf  PIR1
	CLRF        PIR1+0, 0
;frecv_lib_p18f_pic.mbas,95 :: 		MidB = TMR0L
	MOVF        TMR0L+0, 0 
	MOVWF       R9 
;frecv_lib_p18f_pic.mbas,96 :: 		HigB = TMR0H
	MOVF        TMR0H+0, 0 
	MOVWF       R10 
;frecv_lib_p18f_pic.mbas,97 :: 		DO
L__Get_Frecv2:
;frecv_lib_p18f_pic.mbas,98 :: 		inc(LowB)
	INCF        R8, 1 
;frecv_lib_p18f_pic.mbas,99 :: 		RST_pin = 1
	BSF         RST_pin+0, BitPos(RST_pin+0) 
;frecv_lib_p18f_pic.mbas,100 :: 		RST_pin = 0
	BCF         RST_pin+0, BitPos(RST_pin+0) 
;frecv_lib_p18f_pic.mbas,101 :: 		loop until MidB <> TMR0L
	MOVF        R9, 0 
	XORWF       TMR0L+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Get_Frecv5
	GOTO        L__Get_Frecv2
L__Get_Frecv5:
;frecv_lib_p18f_pic.mbas,102 :: 		inc(LowB)
	INCF        R8, 1 
;frecv_lib_p18f_pic.mbas,103 :: 		LowB = not(LowB)
	COMF        R8, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       R8 
;frecv_lib_p18f_pic.mbas,104 :: 		inc(LowB)
	INCF        R0, 1 
	MOVF        R0, 0 
	MOVWF       R8 
;frecv_lib_p18f_pic.mbas,105 :: 		inc(LowB)
	INCF        R0, 1 
	MOVF        R0, 0 
	MOVWF       R8 
;frecv_lib_p18f_pic.mbas,106 :: 		Higher(result) = HigB
	MOVF        R10, 0 
	MOVWF       R6 
;frecv_lib_p18f_pic.mbas,107 :: 		Hi(result) = MidB
	MOVF        R9, 0 
	MOVWF       R5 
;frecv_lib_p18f_pic.mbas,108 :: 		Lo(result) = LowB
	MOVF        R0, 0 
	MOVWF       R4 
;frecv_lib_p18f_pic.mbas,110 :: 		result = result
	MOVF        R4, 0 
	MOVWF       R0 
	MOVF        R5, 0 
	MOVWF       R1 
	MOVF        R6, 0 
	MOVWF       R2 
	MOVF        R7, 0 
	MOVWF       R3 
	RETURN      0
; end of _Get_Frecv
